#include "Back.h"
#pragma warning(disable:4996)
#include "DxLib.h"

sMapLayer map;

//--------------------------------------------------------
//Ǐ擾 ubN̕ǂ̗L𒲂 BlockInfoԂ
//--------------------------------------------------------
Collision::BlockInfo mapGetBlockInfo(int ix, int iy, Back& back)
{
    Collision::BlockInfo ret = 0;

    // ubN1󔒂H
    if (back.mapGetBlockType(ix - 1, iy) == 0)
	{
		ret |= BLOCK_LEFT;
	}
	// ubN̈E󔒂H
	if (back.mapGetBlockType(ix + 1, iy) == 0)
	{
		ret |= BLOCK_RIGHT;
	}
	// ubN̈オ󔒂H
	if (back.mapGetBlockType(ix, iy - 1) == 0)
	{
		ret |= BLOCK_UP;
	}
	//ubN̈󔒂H
	if (back.mapGetBlockType(ix, iy + 1) == 0)
	{
		ret |= BLOCK_DOWN;
	}

    // retɂ4̕ǂ̗L̃rbgdˍ킳Ă
    return ret;
}

void Back::Load()
{
    //^Cg摜ǂݍ
    titleImg = LoadGraph("data/title.png");
    resultImg = LoadGraph("data/result.png");
    defeatImg = LoadGraph("data/defeat.png");
    goalImg = LoadGraph("data/goal.png");

    back1 = LoadGraph("data/back1.png");

    //摜@~cAAcA`bv1̉TCYA`bv1̏cTCYA摜z擪|C^
    LoadDivGraph("data/map.png", chipImgXNum * chipImgYNum, chipImgXNum, chipImgYNum, mapChipSize, mapChipSize, mapChipImg);

    LoadCsv(map, "map/map.csv");
}

//-------------------------------------
//RXgN^ij    
//-------------------------------------
void Back::Init()
{
    //W
    X = 0;
    Y = 0;

    goalX = 100;
    goalY = 710;
}

//-------------------------------------
//fXgN^i㏈j
//-------------------------------------
void Back::Finelize()
{

    DeleteGraph(titleImg);
    DeleteGraph(resultImg);
    DeleteGraph(defeatImg);
    DeleteGraph(goalImg);
    for (int i = 0; i < chipImgXNum * chipImgYNum; i++)
    {
        DeleteGraph(mapChipImg[i]);
    }

    mapUnloader(map);
}

//-------------------------------------
//^Cg`
//-------------------------------------
void Back::DrawTitle()
{
    DrawGraph(X, Y, titleImg, TRUE);
}

//-------------------------------------
//Ug`()
//-------------------------------------
void Back::DrawResult()
{
    DrawGraph(X, Y, resultImg, TRUE);
}

//-------------------------------------
//Ug`(s)
//-------------------------------------
void Back::DrawDefeat()
{
    DrawGraph(X, Y, defeatImg, TRUE);
}

//-------------------------------------
//S[`
//-------------------------------------
void Back::DrawGoal()
{
    DrawGraph(goalX, goalY, goalImg, TRUE);
}

//-------------------------------------
//wi`
//-------------------------------------
void Back::DrawBackAll()
{
    DrawGraph(X, Y, back1, TRUE);
}

//-------------------------------------
//}bv̕`
//-------------------------------------
void Back::DrawCsv(sMapLayer& layer, int scrollOffsetX, int scrollOffsetY, Scroll& scroll)
{
    scrollOffsetX = scroll.scrollGetDrawOffsetX();

    for (int y = 0; y < layer.mapYNum; y++)
    {
        for (int x = 0; x < layer.mapXNum; x++)
        {
            int imgIndex = layer.mapData[y][x];     //  mapzubNނ擾

            //id|1͕̎`XLbv
            if (imgIndex == -1)
            {
                continue;
            }

            int imgHnadle = mapChipImg[imgIndex];   //indexgpĉ摜nhz񂩂摜nh擾

            //}bv`bvŃubN摜~l߂ĕ`悷
            //x0,1,2EEEƕωBx*mapChipSize ̌vZ0,30,60,90EEEƃubNƂɑ
            DrawGraph(x * mapChipSize - scrollOffsetX, y * mapChipSize, imgHnadle, TRUE);
        }
    }
}

//-------------------------------------
//}bv̕`i܂Ƃ߂j
//-------------------------------------
void Back::DrawMap(int scrollOffsetX, int scrollOffsetY, Scroll& scroll)
{
    DrawCsv(map, scrollOffsetX, scrollOffsetY, scroll);
}

bool Back::mapHitCalc(sHitRect& checkRect, Collision& collision, Back& back)
{
    bool hitflg = false;
    sHitRect blockRect;

    blockRect.w = mapChipSize;
    blockRect.h = mapChipSize;

    //}bvubNƒubN̏Փ˂𒲂ׂ
    for (int iy = 0; iy < map.mapYNum; iy++)
    {
        //}bvubNYW
        blockRect.worldLY = static_cast<float>(iy * mapChipSize);
        blockRect.worldRY = static_cast<float>((iy + 1) * mapChipSize);
    
        for (int ix = 0; ix < map.mapXNum; ix++)
        {
            //蔻@OʂAPʂȂ
            if (map.mapData[iy][ix] != 0)
            {
                //}bvubNXW
                blockRect.worldLX = static_cast<float>(ix * mapChipSize);
                blockRect.worldRX = (ix + 1) * static_cast<float>(mapChipSize);

                //Ă邩
                if (collision.isHitRect(checkRect, blockRect))
                {
                    //1xłhitflgtrue
                    hitflg = true;

                    //ubNi㉺E̕ǂ̗Lj
                    Collision::BlockInfo bi = mapGetBlockInfo(ix, iy, back);

                    //{bNX߂荞ݗʂvZ
                    //checkRectɂ͂߂荞ݖ߂ʂ
                    collision.calcFixHitRectPosition(checkRect, blockRect, bi);
                }
            }
        }
    }

    return hitflg;
}

unsigned char Back::mapGetBlockType(int ix, int iy)
{
    if (ix < 0 || iy < 0 || ix >= map.mapXNum || iy >= map.mapYNum)
    {
        return 0;
    }
    return map.mapData[iy][ix];
}

unsigned char Back::mapGetBlockTypeXY(int x, int y)
{
    return mapGetBlockType(x / mapChipSize, y / mapChipSize);
}

//-------------------------------------
//CSVt@C̓ǂݍ
//-------------------------------------
bool Back::LoadCsv(sMapLayer& dst, const char* mapCSVFileName)
{
    dst.mapData = NULL;
    dst.mapXNum = 0;
    dst.mapYNum = 0;

    FILE* fp;
    fp = fopen(mapCSVFileName, "rt");
    if (!fp)
    {
        printf("t@C݂܂");                    // t@Cǂݍ܂ĂȂΏI
        return 0;
    }

    //t@C1sǂ݂
    char c = 0;
    //int cnt = 0;
    while (c != '\n')
    {
        //J}ǂݎƃJEg+1
        c = fgetc(fp);
        if (',' == c)
        {
            dst.mapXNum++;
        }
        //++cnt;
        //printfDx("%d\n", cnt);
    }
    dst.mapXNum++;

    //1̃f[^16bit̍őlu65535vi6jƂĕ񂪓ĂƂ1TCY
    int bufferLen = dst.mapXNum * 6 + 1;

    //1s̃obt@mۂ
    char* buf = new char[bufferLen];
    char* ptmp = buf;

    //t@C|C^擪ɖ߂čēxAsǂ
    fseek(fp, 0, SEEK_SET);
    bool firstRow = true;
    while (fgets(buf, bufferLen - 1, fp) != NULL)
    {
        dst.mapYNum++;
    }

    //2z𓮓Imۂimap[roe][colum]jƂēImۂ
    dst.mapData = new int* [dst.mapYNum];

    int ix, iy;
    for (iy = 0; iy < dst.mapYNum; iy++)
    {
        dst.mapData[iy] = new int[dst.mapXNum];
    }

    //t@C|C^擪ɖ߂
    fseek(fp, 0, SEEK_SET);
    //t@Cf[^zɈڂ
    char* readPoint;
    char* firstPoint;
    for (iy = 0; iy < dst.mapYNum; iy++)
    {
        //1s荞
        fgets(buf, bufferLen - 1, fp);
        readPoint = firstPoint = buf;

        for (ix = 0; ix < dst.mapXNum; ix++)
        {
            //J}܂readPoinẗʒui߂
            while (',' != *readPoint && '\n' != *readPoint)
            {
                readPoint++;
            }
            //J}NULLɒu

            //̎_firstPoint - readPointԂŕ񂪊̂Őlɕϊ
            dst.mapData[iy][ix] = atoi(firstPoint);

            //̃f[^ǂݎʒu܂Ői߂
            readPoint++;
            firstPoint = readPoint;
        }

    }

    //t@C
    fclose(fp);
    //obt@
    delete[] buf;

    return true;
}

//-------------------------------------
//}bv̍폜
//-------------------------------------
void Back::mapUnloader(sMapLayer& dst)
{
    for (int iy = 0; iy < dst.mapYNum; iy++)
    {
        delete[] dst.mapData[iy];
    }
    delete[] dst.mapData;

    // dst̏
    dst.mapData = NULL;
    dst.mapXNum = 0;
    dst.mapYNum = 0;
}