#include "GameManager.h"

LONGLONG nowCount, prevCount;

void Load(Player& player, Back& back, Scroll& scroll, Collision& collision)
{
	//DxLib
	ChangeWindowMode(TRUE);
	DxLib_Init();
	SetDrawScreen(DX_SCREEN_BACK);
	SetGraphMode(1920, 1080, 32);

	if (DxLib_Init() == -1)
	{
		DxLib_End();
	}

	player.Load();
	back.Load();

	nowCount = prevCount = GetNowHiPerformanceCount();
	float fixedDeltaTime = 1.0f / 60.0f;					//601b = 0.1666...b
	float waitFrameTime = 15500;							//16000}CNb = 16~b = 0.016b
}

void Loop(Player& player, Back& back, Scroll& scroll, Collision& collision)
{
	while (ProcessMessage() == 0)
	{
		switch (gameStatus)
		{
		case INIT:

			player.Init(collision);
			back.Init();

			sHitRect stageRect;
			stageRect.worldLX = 0;
			stageRect.worldLY = 0;
			stageRect.worldRX = 30 * 450;	//30hbg450i13500j
			stageRect.worldRY = 30 * 36;	//30hbgc36i1080j

			scroll.scrollManagerInit(1980, 1080, stageRect, collision);
			ClearDrawScreen();

			gameStatus = TITLE;

			ScreenFlip();

			break;


		case TITLE:
			ClearDrawScreen();

			//^Cg`
			back.DrawTitle();

			if (CheckHitKey(KEY_INPUT_RETURN))	//G^[L[ŃvCԂ
			{
				WaitTimer(500.0f);
				gameStatus = PLAY;
			}

			if (CheckHitKey(KEY_INPUT_END))		//EndL[ŏI
			{
				DxLib_End();
			}

 			ScreenFlip();

			break;

		case PLAY:
			//deltaTimev
			float deltaTime;
			nowCount = GetNowHiPerformanceCount();
			deltaTime = (nowCount - prevCount) / 1000000.0f;

			//vC[XV 60fpsz
			player.Update(1.0f / 60.0f, collision, scroll.getPlayArea());

			// vC[̓蔻`
			sHitRect playerRect;
			playerRect = player.getPlayerHitRect();

			// ԂȂ瓖蔻{bNXvC[ʒuC
			if (back.mapHitCalc(playerRect, collision, back))
			{
				player.playerfixColPosition(playerRect);
			}

			//`FbN
			playerRect = player.playerGetGroundCollider();
			player.playerSetGroundFlg(back.mapHitCalc(playerRect, collision, back));

			//`FbN
			playerRect = player.playerGetHeadCollider();
			player.playerSetHeadHitFlg(back.mapHitCalc(playerRect, collision, back));

			//XN[XV
			scroll.scrollUpdate(playerRect, deltaTime, collision);

			//XN[ʎ擾
			int scrOffsX, scrOffsY;
			scrOffsX = scroll.scrollGetDrawOffsetX();
			scrOffsY = 0;

			//ʍXV
			ClearDrawScreen();

			back.DrawBackAll();

			// }bv̕`
			back.DrawMap(scrOffsX, scrOffsY, scroll);

			//vC[̕`
			player.Draw(scrOffsX, scrOffsY, scroll);
			

			//S[`
			//back.DrawGoal();

			if (player.py >= 1030)
			{
				WaitTimer(500.0f);
				gameStatus = DEFEAT;
			}

			if (player.px >= 13200 && player.py >= 750)
			{
				WaitTimer(500.0f);
				gameStatus = CLEAR;
			}

			ScreenFlip();
			prevCount = nowCount;

			if (CheckHitKey(KEY_INPUT_ESCAPE))	//G^[L[Ń^Cg
			{
				gameStatus = INIT;		// Ԃɂ
			}

			break;

		case CLEAR:
			ClearDrawScreen();

			back.DrawResult();

			if (CheckHitKey(KEY_INPUT_RETURN))	//G^[L[Ń^Cg
			{
				WaitTimer(500.0f);
				gameStatus = INIT;
			}
			
			if (CheckHitKey(KEY_INPUT_END))		//EndL[ŏI
			{
				DxLib_End();
			}

			ScreenFlip();

			break;


		case DEFEAT:
			ClearDrawScreen();

			back.DrawDefeat();

			if (CheckHitKey(KEY_INPUT_RETURN))	//G^[L[Ń^Cg
			{
				WaitTimer(500.0f);
				gameStatus = INIT;
			}

			if (CheckHitKey(KEY_INPUT_END))		//EndL[ŏI
			{
				DxLib_End();
			}

			ScreenFlip();

			break;

		default:
			break;
		}
	}

	//fXgN^
	player.Finalize();
	back.Finelize();

	//DXCǔn
	DxLib_End();
}
